"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("..");
describe('asError', () => {
    test('Error', () => {
        const error = new Error('failed');
        expect(__1.asError(error)).toEqual(error);
    });
    test('string', () => {
        expect(__1.asError('failed').message).toEqual('failed');
    });
});
describe('Try', () => {
    test('return right', done => {
        const result = __1.Try(() => {
            return 'succeeded';
        });
        if (result.isLeft()) {
            return done.fail();
        }
        expect(result.value).toBe('succeeded');
        done();
    });
    test('return left', done => {
        const result = __1.Try(() => {
            throw 'failed';
        });
        if (result.isRight()) {
            return done.fail();
        }
        expect(result.value).toBeInstanceOf(Error);
        expect(result.value.message).toBe('failed');
        done();
    });
});
describe('TryAsync', () => {
    test('return right', (done) => __awaiter(this, void 0, void 0, function* () {
        const result = yield __1.TryAsync(() => __awaiter(this, void 0, void 0, function* () {
            return 'succeeded';
        }));
        if (result.isLeft()) {
            return done.fail();
        }
        expect(result.value).toBe('succeeded');
        done();
    }));
    test('return left', (done) => __awaiter(this, void 0, void 0, function* () {
        const result = yield __1.TryAsync(() => __awaiter(this, void 0, void 0, function* () {
            throw 'failed';
        }));
        if (result.isRight()) {
            return done.fail();
        }
        expect(result.value).toBeInstanceOf(Error);
        expect(result.value.message).toBe('failed');
        done();
    }));
});
//# sourceMappingURL=main.test.js.map