"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Either_1 = require("fp-ts/lib/Either");
exports.asError = (value) => (value instanceof Error ? value : new Error(value));
function Try(fn) {
    try {
        const result = fn();
        return Either_1.right(result);
    }
    catch (error) {
        return Either_1.left(exports.asError(error));
    }
}
exports.Try = Try;
function TryAsync(fn) {
    return __awaiter(this, void 0, void 0, function* () {
        return fn()
            .then(v => Either_1.right(v))
            .catch(error => Either_1.left(exports.asError(error)));
    });
}
exports.TryAsync = TryAsync;
//# sourceMappingURL=index.js.map